unit AlphaBitmapUnit;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  PCardinalArray = ^TCardinalArray;
  TCardinalArray = array[0..8191] of Cardinal;

function GetAlphaBitmapByBitmap(ABitmap : TBitmap; AlphaValue : Byte): HBitmap;
function GetAlpha32BitmapByBitmap(ABitmap : TBitmap; AlphaValue : Byte): TBitmap;
function GetARGBBitmap(A,R,G,B : Byte;AWidth,Aheight : Integer): HBitmap;
function GetARGB32Bitmap(A,R,G,B : Byte;AWidth,Aheight : Integer): TBitmap;
implementation
function GetAlphaBitmapByBitmap(ABitmap : TBitmap; AlphaValue : Byte): HBitmap;
var
  p1,p2 : pByteArray;
  B1 : TBitmap;
  i,j : integer;
  MyBitmapStructure : tagBitmap;
  pData : pByte;
begin
  B1:=TBitmap.Create;
  B1.PixelFormat:=pf24Bit;

  B1.Width:=ABitmap.Width;
  B1.Height:=Abitmap.Height;
  B1.canvas.Draw(0,0,ABitmap);
  MyBitmapStructure.bmType:=0;
  MyBitmapStructure.bmWidth:=B1.Width;
  MyBitmapStructure.bmHeight:=B1.Height;
  MyBitmapStructure.bmWidthBytes:=B1.Width*4;
  MyBitmapStructure.bmPlanes:=1;
  MyBitmapStructure.bmBitsPixel:=32;

  getmem(pData,B1.Height*B1.Width*4);
  MyBitmapStructure.bmBits:=pData;

  for i:=0 to B1.Height-1 do
    begin
      p1:=B1.ScanLine[i];
      p2:=pByteArray(integer(pData)+i*B1.Width*4);
      for j:=0 to B1.Width-1 do
        begin
          p2[j*4+0]:=p1[j*3];
          p2[j*4+1]:=p1[j*3+1];
          p2[j*4+2]:=p1[j*3+2];
          p2[j*4+3]:=AlphaValue;
        end;
    end;
  result:=createBitmapIndirect(MyBitmapStructure);
  freemem(pData,B1.Height*B1.Width*4);
  B1.free;
end;
function GetAlpha32BitmapByBitmap(ABitmap : TBitmap; AlphaValue : Byte): TBitmap;
var
  MyHBitmap : HBitmap;
begin
  MyHBitmap:= GetAlphaBitmapByBitmap(ABitmap,AlphaValue);
  Result:=TBitmap.Create;
  Result.PixelFormat:=pf32bit;
  Deleteobject(Result.ReleaseHandle);
  result.Handle:=MyHBitmap;
end;

function GetARGBBitmap(A,R,G,B : Byte;AWidth,Aheight : Integer): HBitmap;
var
  p2 : PCardinalArray;
  i : integer;
  MyBitmapStructure : tagBitmap;
  pData : pByte;
  AValue : Cardinal;
begin
  MyBitmapStructure.bmType:=0;
  MyBitmapStructure.bmWidth:=AWidth;
  MyBitmapStructure.bmHeight:=AHeight;
  MyBitmapStructure.bmWidthBytes:=AWidth*4;
  MyBitmapStructure.bmPlanes:=1;
  MyBitmapStructure.bmBitsPixel:=32;

  getmem(pData,AHeight*AWidth*4);
  MyBitmapStructure.bmBits:=pData;
  //Prepare to fill the array quicly
  if AHeight>0 then
    begin
      AValue:=(((((A shl 8) or R) shl 8) or G) shl 8) or B;
      p2:=pCardinalArray(integer(pData));
      for i:=0 to AWidth -1 do p2[i]:=AValue;
      for i:=1 to AHeight -1 do CopyMemory(pointer(integer(p2)+i*AWidth*4),p2,AWidth*4);
    end;
  result:=createBitmapIndirect(MyBitmapStructure);
  freemem(pData,AHeight*AWidth*4);
end;
function GetARGB32Bitmap(A,R,G,B : Byte;AWidth,Aheight : Integer): TBitmap;
var
  MyHBitmap : HBitmap;
begin
  MyHBitmap:= GetARGBBitmap(A,R,G,B,AWidth,Aheight);
  Result:=TBitmap.Create;
  Result.PixelFormat:=pf32bit;
  Deleteobject(Result.ReleaseHandle);
  result.Handle:=MyHBitmap;
end;
end.
